#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
	int T;
	cin >> T;
	while (T--)
	{
		long long i;
		long long j;
		long long n, m;
		cin >> n >> m;
		  long a[75001];
		  long b[75001];

		for (i = 0; i < n; i++)
		{
			cin >> a[i];
		}
		for (i = 0; i < m; i++)
		{
			cin >> b[i];
		}
		sort(a, a + n);
		sort(b, b + m);

		long long x = a[1] - a[0];
		long long ostatak = a[0] % x;
		int c = 1;

		for ( i = 0; i < n; i++)
		{
			if (a[i] % x != ostatak)
			{
				c = 0;
			}				
		}
		

		for ( j = 0; j < m; j++)
		{
			if (b[j] % x == ostatak)
			{
				c = 0;
			}		
		}

		cout << c << endl;
	}	
	return 0;
}